/*
 * ImageTemplate.h
 *
 *  Created on: 01/giu/2010
 *      Author: bertini
 */

#ifndef IMAGETEMPLATE_H_
#define IMAGETEMPLATE_H_

template<typename T>
class ImageTemplate {
public:
	ImageTemplate(int w, int h) : _w(w), _h(h) { _pixels = new T[_w * _h]; };
	~ImageTemplate() { delete[] _pixels; };

	T getPixel(int x, int y) const;
	void setPixel(int x, int y, const T& pixel);

private:
	int _w, _h;
	T* _pixels;
};

template<typename T>
T ImageTemplate<T>::getPixel(int x, int y) const {
	return _pixels[x + _w * y];
}

template<typename T>
void ImageTemplate<T>::setPixel(int x, int y, const T& pixel) {
	_pixels[x + _w * y] = pixel;
}

#endif /* IMAGETEMPLATE_H_ */
